      // Listing 11.13

      // Linked list simple implementation


      #include <iostream.h>


      // object to add to list

      class CAT

      {

      public:

        CAT() { itsAge = 1;}

        CAT(int age):itsAge(age){}

        ~CAT(){};

        int GetAge() const { return itsAge; }

     private:

        int itsAge;

     };


     // manages list, orders by cat's age!

     class Node

     {

     public:

        Node (CAT*);

        ~Node();

        void SetNext(Node * node) { itsNext = node; }

        Node * GetNext() const { return itsNext; }

        CAT * GetCat() const { return itsCat; }

        void Insert(Node *);

        void Display();

     private:

        CAT *itsCat;

        Node * itsNext;

     };



     Node::Node(CAT* pCat):

     itsCat(pCat),

     itsNext(0)

     {}


     Node::~Node()

     {

        cout << "Deleting node...\n";

        delete itsCat;

        itsCat = 0;

        delete itsNext;

        itsNext = 0;

     }


     // ************************************

     // Insert

     // Orders cats based on their ages

     // Algorithim: If you are last in line, add the cat

     // Otherwise, if the new cat is older than you

     // and also younger than next in line, insert it after

     // this one. Otherwise call insert on the next in line

     // ************************************

     void Node::Insert(Node* newNode)

     {

        if (!itsNext)

           itsNext = newNode;

        else

        {

           int NextCatsAge = itsNext->GetCat()->GetAge();

           int NewAge =  newNode->GetCat()->GetAge();

           int ThisNodeAge = itsCat->GetAge();


           if (  NewAge >= ThisNodeAge && NewAge < NextCatsAge  )

           {

              newNode->SetNext(itsNext);

              itsNext = newNode;

           }

           else

              itsNext->Insert(newNode);

        }

     }


     void Node::Display()

     {

        if (itsCat->GetAge() > 0)

        {

           cout << "My cat is ";

           cout << itsCat->GetAge() << " years old\n";

        }

        if (itsNext)

           itsNext->Display();

     }


     int main()

     {


        Node *pNode = 0;

        CAT * pCat = new CAT(0);

        int age;


        Node *pHead = new Node(pCat);


        while (1)

        {

           cout << "New Cat's age? (0 to quit): ";

           cin >>  age;

           if (!age)

              break;

          pCat = new CAT(age);

          pNode = new Node(pCat);

          pHead->Insert(pNode);

       }

       pHead->Display();

       delete pHead;

       cout << "Exiting...\n\n";

    return 0;

    }

